unit example;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, formula;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    ePrice: TEdit;
    Label2: TLabel;
    eFreight: TEdit;
    Label3: TLabel;
    eInsurance: TEdit;
    Label4: TLabel;
    eTax: TEdit;
    Label5: TLabel;
    Panel1: TPanel;
    Label6: TLabel;
    Panel2: TPanel;
    Button1: TButton;
    Label7: TLabel;
    Total: TPanel;
    Costs: TFormula;
    Formula1: TFormula;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
   // Generate Sub-Formula
   Costs.Formula:='FOB+FREIGHT+INSURANCE';
   // set the values , this HAS to be done before the sub-formula is used
   Costs.SetParameterValues([StrToFloat(ePrice.Text),
                           StrToFloat(eFreight.Text),
                           StrToFloat(eInsurance.Text)]);

   // Now tell Formula1 what to do
   Formula1.Formula:='Costs * (1+Tax/100)';  // Tax is a parameter

   // Pass the subformula to Formula1
   // first parameter is the name to be used in the formula : here 'CIF'
   // second parameter is the instance of Tformula to become a subformula : here CIF
   Formula1.AddSubFormula('Costs',Costs);

   // Now calculate formula1

   Total.Caption:=FloatToStrF( Formula1.Calculate([ StrToFloat(eTax.Text) ]),ffFixed,20,2);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   DecimalSeparator:='.';
end;

end.



